(* device driver for Intel EtherExpress adaptor *)

signature EEXPRESS = sig
	exception RESET_FAILURE
	exception INIT_FAILURE
	exception EEXPRESS_IN_USE
	exception NO_EEXPRESS_IN_USE
	exception UNKNOWN_DEV_INTERRUPT
	exception ILLEGAL_OR_UNUSED_INTERRUPT_ID

        type T
	type irq 
 (* probe raises UNKNOWN_DEV_INTERRUPT if the device is not found *)
	val probe:  ( string * irq ) -> T
	val dev_open: T -> unit
	val get_ethernet_address: T -> Word8Array.array
        val dev_close: T -> unit
	val send: ( T * Word8Array.array) -> unit
        val receive: (T * Word8Array.array * int ) -> int  
        val irqToDev: irq -> T option
        val devToIrq: T -> irq
	val handle_irq: (irq -> unit) -> irq -> unit 

end








