(* device driver for Ethernet Adaptor *)
(* translated to SML and adapted from Linux Debian version 2.0.33
   file: linux/if_ether.h
   GF 2/1999
 *)
signature ETHCONSTANT = sig
	(* following constant value came from linux/if_ether.h *)

	(*
	 *      IEEE 802.3 Ethernet magic constants.  The frame sizes omit the preamble
	 *      and FCS/CRC (frame check sequence).
	 *)
	val ETH_ALEN :int		(* Octets in one ethernet addr   *)
	val ETH_HLEN :int        	(* Total octets in header.       *)
	val ETH_ZLEN :int         	(* Min. octets in frame sans FCS *)
	val ETH_DATA_LEN :int	       (* Max. octets in payload        *)  
	val ETH_FRAME_LEN :int	       (* Max. octets in frame sans FCS *)

	(*
	 *	These are the defined Ethernet Protocol ID's.
	 *)

	val ETH_P_LOOP	:int		(* Ethernet Loopback packet	*)
	val ETH_P_ECHO	:int		(* Ethernet Echo packet		*)
	val ETH_P_PUP	:int		(* Xerox PUP packet		*)
	val ETH_P_IP	:int		(* Internet Protocol packet	*)
	val ETH_P_X25	:int		(* CCITT X.25			*)
	val ETH_P_ARP	:int		(* Address Resolution packet	*)
	val ETH_P_BPQ	:int		(* G8BPQ AX.25 Ethernet Packet	
				   	   [ NOT AN OFFICIALLY REGISTERED ID ] *)
	val ETH_P_DEC   :int          	(* DEC Assigned proto           *)
	val ETH_P_DNA_DL:int          	(* DEC DNA Dump/Load            *)
	val ETH_P_DNA_RC:int          	(* DEC DNA Remote Console       *)
	val ETH_P_DNA_RT:int             (* DEC DNA Routing              *)
	val ETH_P_LAT   :int          	(* DEC LAT                      *)
	val ETH_P_DIAG  :int          	(* DEC Diagnostics              *)
	val ETH_P_CUST  :int          	(* DEC Customer use             *)
	val ETH_P_SCA   :int          	(* DEC Systems Comms Arch       *)
	val ETH_P_RARP  :int	     	(* Reverse Addr Res packet	*)
	val ETH_P_ATALK	:int	     	(* Appletalk DDP		*)
	val ETH_P_AARP	:int	     	(* Appletalk AARP		*)
	val ETH_P_IPX	:int	     	(* IPX over DIX			*)
	val ETH_P_IPV6	:int	     	(* IPv6 over bluebook		*)

	(*
	 *	Non DIX types. Won't clash for 1500 types.
	 *)
	 
	val ETH_P_802_3	:int		 (* Dummy type for 802.3 frames  *)
	val ETH_P_AX25	:int		(* Dummy protocol id for AX.25  *)
	val ETH_P_ALL	:int		(* Every packet (be careful!!!) *)
	val ETH_P_802_2	:int		(* 802.2 frames 		*)
	val ETH_P_SNAP	:int		(* Internal only		*)
	val ETH_P_DDCMP :int                  (* DEC DDCMP: Internal only     *)
	val ETH_P_WAN_PPP  :int              	(* Dummy type for WAN PPP frames*)
	val ETH_P_PPP_MP   :int              	(* Dummy type for PPP MP frames *)
	val ETH_P_LOCALTALK:int		(* Localtalk pseudo type 	*)
	val ETH_P_PPPTALK  :int		(* Dummy type for Atalk over PPP*)
	val ETH_P_TR_802_2 :int		(* 802.2 frames 		*)


end
