(* signature for pc assembly interface *)

signature ASM = sig
	val getID:unit -> int
	val sti:unit -> unit
	val cli:unit -> unit
	val inb:int -> int  (* port->value *)
	val inb_p: int -> int
	val outb: ( int * int )  -> unit (* (value, port)->unit *)
	val outb_p: ( int * int ) -> unit 
	val set_bit: ( int * word) -> int
	val clear_bit: ( int * word) -> int 
	val inw: int -> int (* port -> value *) 
	val outw: (int * int) -> unit (* (value, port)->unit *)
	val inw_p: int -> int (* port -> value *) 
	val outw_p: (int * int) -> unit (* (value, port)->unit *)
	val insw: (int * Word32.word * int ) -> unit  (* (port, addr, count)->unit *) 
	val outsw:(int * Word32.word * int ) -> unit  (* (port, addr, count)->unit *)
	val request_region:(int*int*string) -> unit  (* (from, size, dev_name)->unit *)
	val release_region:(int*int)->unit 	     (* (from, size)->unit *)

	val request_irq:(int*int*string) -> int  (* (irqID, flags, name)->int *) 
	val free_irq: int->unit 

end
